C SOLVE THE KNIGHT'S TOUR USING WARNSDORFF'S RULE (ALWAYS
C MOVING TO THE SQUARE HAVING THE FEWEST ONWARD MOVES)
C DEVELOPED BY DUDLEY J. BENTON
C ORIGINAL VERSION 1974 FLORIDA ATLANTIC UNIVERSITY

      LOGICAL FUNCTION MOVEOK(IX,IY)
      IMPLICIT INTEGER (I-N),REAL (A-H,O-Z)
      COMMON/ARRAYS/IBOARD(8,8),MOVEX(8),MOVEY(8)
      IF(IX.LT.1)THEN
        MOVEOK=.FALSE.
      ELSE IF(IX.GT.8)THEN
        MOVEOK=.FALSE.
      ELSE IF(IY.LT.1)THEN
        MOVEOK=.FALSE.
      ELSE IF(IY.GT.8)THEN
        MOVEOK=.FALSE.
      ELSE IF(IBOARD(IY,IX).NE.0)THEN
        MOVEOK=.FALSE.
      ELSE
        MOVEOK=.TRUE.
      ENDIF
      RETURN
      END

      INTEGER FUNCTION MOVES(IX,IY)
      IMPLICIT INTEGER (I-N),REAL (A-H,O-Z)
      COMMON/ARRAYS/IBOARD(8,8),MOVEX(8),MOVEY(8)
      LOGICAL MOVEOK
      MOVES=0
      DO 100 I=1,8
        IF(MOVEOK(IX+MOVEX(I),IY+MOVEY(I)))THEN
          MOVES=MOVES+1
        ENDIF
  100 CONTINUE
      RETURN
      END

      SUBROUTINE SHOWBOARD
      IMPLICIT INTEGER (I-N),REAL (A-H,O-Z)
      COMMON/ARRAYS/IBOARD(8,8),MOVEX(8),MOVEY(8)
      DO 100 I=8,1,-1
        WRITE(*,1000)(IBOARD(I,J),J=1,8)
 1000   FORMAT(8I3)
  100 CONTINUE
      RETURN
      END

      SUBROUTINE TOUR(IX1,IY1)
      IMPLICIT INTEGER (I-N),REAL (A-H,O-Z)
      COMMON/ARRAYS/IBOARD(8,8),MOVEX(8),MOVEY(8)
      DO 110 I=1,8
        DO 100 J=1,8
          IBOARD(I,J)=0
  100   CONTINUE
  110 CONTINUE
      IBOARD(IY1,IX1)=1
      M=0
  200 N1=9
      DO 210 I=1,8
        IX2=IX1+MOVEX(I)
        IY2=IY1+MOVEY(I)
        IF(.NOT.MOVEOK(IX2,IY2))GOTO 210
        IF(M.EQ.62)THEN
          IX3=IX2
          IY3=IY2
          GOTO 220
        ENDIF
        N2=MOVES(IX2,IY2)
        IBOARD(IY2,IX2)=0
        IF(N2.LT.1.OR.N2.GE.N1)GOTO 210
        IX3=IX2
        IY3=IY2
        N1=N2
  210 CONTINUE
  220 IF(N1.EQ.9.AND.M.NE.62)THEN
        WRITE(*,*)'FAILED'
        RETURN
      ENDIF
      M=M+1
      IX1=IX3
      IY1=IY3
      IBOARD(IY3,IX3)=M+1
      IF(M.EQ.63)THEN
        WRITE(*,*)'SUCCESS'
        RETURN
      ENDIF
      GOTO 200
      END

      BLOCK DATA
      COMMON/ARRAYS/IBOARD(8,8),MOVEX(8),MOVEY(8)
      DATA MOVEX/1,2, 2, 1,-1,-2,-2,-1/
      DATA MOVEY/2,1,-1,-2,-2,-1, 1, 2/
      END

      PROGRAM MAIN
      IMPLICIT INTEGER (I-N),REAL (A-H,O-Z)
      WRITE(*,1000)
 1000 FORMAT('ENTER X,Y FOR FIRST SQUARE (1,1) TO (8,8)')
      READ(*,*)IX,IY
      CALL TOUR(IX,IY)
      CALL SHOWBOARD()
      STOP
      END
      